/* ntris -- a product of Sadistic Software. Copyright 1990, Andrew Plotkin. */

#include <stdio.h>
#include <sys/types.h>
#include <curses.h>
#include <errno.h>
#include "ntris.h"

extern char *sprintf();

draw_frame ()
{
    int i;

    for (i = 0; i < game_depth; i++) {
	mvaddch (i, 0, '|');
	addch ('|');
	mvaddch (i, 2*game_width+2, '|');
	addch ('|');
    }

    move (game_depth, 2);
    for (i = 0; i < 2*game_width; i++)
	addch ('=');

    mvaddch (game_depth, 0, '=');
    addch ('=');
    mvaddch (game_depth, 2*game_width+2, '=');
    addch ('=');

    mvaddstr (3, 2*game_width+6, "NTRIS");

    mvaddstr (5, 2*game_width+6, "Score:");
}

draw_score()
{
    char form_buffer[LINELEN];

    (void)sprintf(form_buffer, "%d", score);
    mvaddstr (7, 2*game_width+6, form_buffer);
}

draw_piece(ptr, px, py, drawch)
gpiece *ptr;
int px, py;
char drawch; /* char to draw with. '\0' means ' ' but not inverted. */
{
    int posx, posy; /* coords of top corner */
    register int ix, iy;
    char invflag = 0;

    if (drawch == '\0') {
	drawch = ' ';
    }
    else {
	standout();
	invflag = 1;
    };

    posx = px-(ptr->cenx);
    posy = py-(ptr->ceny);

    for (iy=ptr->dep-1; iy>=0; iy--)
	for (ix=ptr->wid-1; ix>=0; ix--) 
	    if (ptr->blk[iy*(ptr->wid)+ix]) 
		if (posy+iy>=0) {
		    mvaddch(posy+iy, (posx+ix+1) * 2, drawch);	
		    addch(drawch);
		}

    if (invflag) standend();
}

redraw_board()
{
    register int ix, iy;
    char tc, invflag=0;

    for (iy=0; iy<game_depth; iy++) {
	move(iy, 2);
	for (ix=0; ix<game_width; ix++) {
	    tc = game_board[iy*game_width+ix];
	    if (tc) {
		if (!invflag) {
		    invflag=1;
		    standout();
		}
	    }
	    else
		if (invflag) {
		    invflag=0;
		    standend();
		}
	    addch(' ');
	    addch(' ');
	}
    };
    standend();
    myrefresh();
}

