/* ntris -- a product of Sadistic Software. Copyright 1990, Andrew Plotkin. */

#include <strings.h>
#include "ntris.h"

long score;
int game_width, game_depth;
gpiece piece_list[MAX_PIECES][4];
int num_pieces;
char *game_board;
int in_curses = 0;		/* Set to 1 after initialisation */

main(argc, argv)
int argc;
char *argv[];
{
    register int ix;
    int fullpath, anum;
    char infile[1025]; /* fill *that*! */
    char D_flag=0, d_flag=0, c_flag=0, s_flag=0, f_flag=0;

    if (argc<2)
	die(LE_ARGS, "usage: ntris [-d] [-D] [-s] [-c] piecefilename");
    
    for (anum=1; anum<argc; anum++) {
	if (!strcmp(argv[anum], "-d")) {
	    d_flag = 1;
	}
	else if (!strcmp(argv[anum], "-D")) {
	    D_flag = 1;
	}
	else if (!strcmp(argv[anum], "-s")) {
	    s_flag = 1;
	}
	else if (!strcmp(argv[anum], "-c")) {
	    c_flag = 1;
	}
	else if (argv[anum][0] == '-') {
	    printf("ntris: bad option: %s\n", argv[anum]);
	    die(LE_ARGS, "exiting.");
	}
	else {
	    f_flag=1;
	    fullpath=0;
	    for (ix=0; (fullpath==0 && argv[anum][ix]!='\0'); ix++)
		if (argv[anum][ix]=='/') fullpath=1;
	    if (fullpath) {
		(void)strcpy(infile, argv[anum]);
	    }
	    else {
		(void)strcpy(infile, PIECE_LIBRARY);
		(void)strcat(infile, argv[anum]);
	    };
	    ix = strlen(infile);
	    if (strcmp(infile+ix-3, ".pc")) (void)strcat(infile, ".pc");
	}
    };

    if (c_flag) {
	printf("library directory is %s\n\n", PIECE_LIBRARY);
	(void)strcpy(infile, "ls ");
	(void)strcat(infile, PIECE_LIBRARY);
	(void)system(infile);
	die(LE_OK, "");
    };

    if (s_flag) {
	printf("ntris: no high score list available yet...\n");
	die(LE_OK, "");
    };

    if (!f_flag) {
	die(LE_ARGS, "name of piece file required");
    };

    load_pieces(infile);

    if (d_flag || D_flag) {
	for (ix=0; ix<num_pieces; ix++) {
	    dump_set(ix, D_flag);
	};
	die(LE_OK, "");
    }
    
    init_game();
    die (LE_OK, "");

}

