/* ntris -- a product of Sadistic Software. Copyright 1990, Andrew Plotkin. */

#define PIECE_LIBRARY "/afs/andrew.cmu.edu/usr15/ap1i/lib/ntris/"
#define PROG_NAME "ntris"

#define MAX_PIECES 50

typedef struct _gpiece {
    int wid, dep;
    int cenx, ceny;
    char *blk; /* grid is y*wid+x */
} gpiece;

extern long score;
extern int game_width, game_depth;
extern gpiece piece_list[MAX_PIECES][4];
extern int num_pieces;
extern char *game_board;

#ifndef cbreak()
#define cbreak() crmode()
#endif

#ifndef nocbreak()
#define nocbreak() nocrmode()
#endif

#define LINELEN		160	/* Maximum length of a line of text */

#define LE_OK		0	/* No problems, me ole' fruit-bat */
#define LE_USAGE	1	/* Command-line syntax was wrong */
#define LE_ENV		2	/* Couldn't get environment variable */
#define LE_TERMCAP	3	/* Couldn't get a termcap entry */
#define LE_SCREEN	4	/* Screen was too small for game */
#define LE_SIGNAL	5	/* Signal(3) call failed */
#define LE_SELECT	6	/* Select(2) call failed */
#define LE_READ		7	/* Read(2) call failed */
#define LE_MALLOC	8	/* Couldn't allocate memory */
#define LE_LEVEL	9	/* User wanted to play on a silly level */
#define LE_OPEN		10	/* Open(2) call failed */
#define LE_STAT		11	/* {f,l,}stat(2) call failed */
#define LE_WRITE	12	/* write(2) call failed */
#define LE_GETUID	13	/* getuid(2) call failed */
#define LE_GETPW	14	/* getpwuid(3) call failed */
#define	LE_PIECE	15
#define	LE_ARGS		16

extern int errno;

extern int in_curses;		/* Set to 1 after initialisation */

extern draw_frame();
extern draw_score();
extern redraw_board();
extern draw_piece();
 
extern void signal_end();
extern char get_key();
extern void print_msg();
extern void myrefresh();
extern void die();
extern void flush_keyboard();

extern load_pieces();
extern dump_piece();
extern dump_set();

extern init_game();
