/* ntris -- a product of Sadistic Software. Copyright 1990, Andrew Plotkin. */

#include <curses.h>
#include <sys/types.h>
#include <sys/time.h>
#include <errno.h>
#include "ntris.h"

void signal_end()
{
    if (in_curses)
	print_msg ("Aborted!");

    die (LE_OK, "");
}

char get_key() /* pauses and waits for input */
{
    char ch;

    (void)read(0, &ch, 1);
    return ch;
}

void print_msg(line)
char *line;
{
    move(game_depth+1, 1);
    clrtoeol();

    if ((line != NULL) && (*line != '\0')) {
	addstr(line);
    };
    myrefresh();
}

void myrefresh()
{
    int ix = game_depth+2;

    if (ix > LINES-1)
	ix = LINES-1;

    move(ix, 0);
    refresh();
}

void die(status, line)
int status;
char *line;
{
    if (in_curses) {
	myrefresh();
	nocbreak();
	echo();
	endwin();
    }

    if (line!=NULL && line[0]!='\0')
	(void)printf("%s: %s\n", PROG_NAME, line);

    exit(status);
}

void flush_keyboard()
{
    fd_set fds;	
    struct timeval timeout;
    static char buffer[LINELEN];
    int status;	

    while (1) {
	/*FD_ZERO(&fds);
	FD_SET(0, &fds);*/
	bzero((char *)(&fds), sizeof(fds));
	fds.fds_bits[0] |= (1 << 0);
	timeout.tv_sec = 0L;
	timeout.tv_usec = 0L;
	if (((status = select(1, &fds, (fd_set *)NULL, (fd_set *)NULL,
			       &timeout)) == -1) && (errno != EINTR))
	    die (LE_SELECT, "select failed in flush_keybord()");
	if ((status == 0) || (status == -1))
	    break;			/* Can only be -1 if errno == EINTR */
	(void)read(0, buffer, LINELEN);
    }
}

